/*
 * fpu.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * FPU
 */


#include <sys/config.h>
#include <sys/types.h>
#include <sys/param.h>
#include <machine/lib.h>
#include <kern/proc.h>
#include <kern/mm.h>
#include <kern/lock.h>

#include <kern/debug.h>


//#define DEBUG_I386_FPU 1
#ifdef DEBUG_I386_FPU
	#define STATIC
	#define INLINE
#else
	#define STATIC	static
	#define INLINE	inline
#endif


//================================== PRIVATE ============================================

// ľΥǥХԲ㳰򵯤ץFPUʪɥ쥹
static uint fpuSaveAddr[MAX_CPU];

//================================== PUBLIC =============================================

/*
 * ưFPUν
 */
void initFpu()
{
	asm("fninit");
}

/*
 * ץFPU֥ɥ쥹ꤹ
 *ռץƤӽФ
 */
/*void initFpuSaveAddr()
{
	PROC *proc = get_current_task();

	proc->fpuSaveAddr = NULL;
	proc->fpuSaveCrnt = proc->fpuSave;
}
*/
/*
 * FPU֥ɥ쥹򥯥ꥢ
 *ռץƤӽФ
 */
void clearFpuSaveAddr()
{
	int eflags;
	uint physFpuSave = getPhysicalFromLogicalAddr(get_current_task(), KERNEL_SAVE_FPU);

	eflags = enterCli();
	{
		if (physFpuSave == fpuSaveAddr[getCpu()]) {
			fpuSaveAddr[getCpu()] = 0;
		}
	}
	exitCli(eflags);
}

/*
 * FPU֥ɥ쥹桼ϥɥƤӽФڤؤ
 *ռץƤӽФ
 */
/*void changeFpuSaveAddr()
{
	get_current_task()->fpuSaveCrnt = get_current_task()->fpuSaveUserCall;
}
*/
/*
 * FPU֥ɥ쥹᤹̾
 *ռץƤӽФ
 */
/*void resetFpuSaveAddr()
{
	get_current_task()->fpuSaveCrnt = get_current_task()->fpuSave;
}
*/
/*
 * ǥХԲ㳰
 *ճԲĤǸƤӽФ롣
 */
void doCoprocessorNotAvailable()
{
	uint saveAddr = getPhysicalFromLogicalAddr(get_current_task(), KERNEL_SAVE_FPU);

	// ǥХԲ㳰ȥå
	clearTs();

	/*
	 * ǥХԲ㳰ȥåפ㳰ȯץFPU³Ԥ
	 * ǥХԲ㳰ϥѤȤ˥Ȥ
	 */
	if (saveAddr != fpuSaveAddr[getCpu()]) {
		if (0 != fpuSaveAddr[getCpu()]) {
			// FPU쥸򥻡֤
			fpuSave(fpuSaveAddr[getCpu()]);
		}

		// ץΥ֤ƤFPU쥸ƥȤ᤹
/*		if (0 != get_current_task()->fpuFlag) {
			fpuStore(KERNEL_SAVE_FPU);
		}
		else {
			get_current_task()->fpuFlag = 1;
		}*/
		fpuStore(KERNEL_SAVE_FPU);
		
		// ץFPUΰ򼡤FPU쥸򥻡֥ɥ쥹ꤹ
		fpuSaveAddr[getCpu()] = saveAddr;
	}
}

/*************************************************************************************************/
void test_fpu()
{
}
/**************************************************************************************************/
