/*
 * interrupt.c
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#include <sys/param.h>
#include <i386/segment.h>
#include <kern/lib.h>
#include <kern/mp.h>
#include <kern/mm.h>
#include <machine/segment.h>
#include <machine/mode_switch.h>
#include <machine/interrupt.h>

#include <kern/debug.h>


enum {
	IDT_ENTRY = 256			/* Interrupt descriptorȥ꡼ */
};

DESCRIPTOR idt[IDT_ENTRY];				/* IDT */
DTR idtr = {IDT_ENTRY * 8 - 1, idt};	/* IDT Reg */

static int temp(int irq)
{
	printk("interrupt : %d\n", irq);
	return 0;
}

/*
 * ߥϥɥơ֥
 * returns : task switch on 1,off 0
 */
int (*irq_entry[IRQ_ENTRY])(int)={
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp,
	temp
};

/*
 * ϡɳѣţϣɴؿ
 * parameters : IRQ number
 */
void (*irq_eoi)(uchar);

/*
 * Release hard interrupt mask
 * parameters : IRQ number
 */
void (*release_irq_mask)(uchar);

/*
 * Set hard interrupt mask
 * parameters : IRQ number
 */
void (*set_irq_mask)(uchar);

/*
 * IDTꤹ
 * parameters : IDT number,Hnadler address,Gate flag(IDT_INTR or IDT_TRAP)
 */
void set_idt(int num,void *func,int flag)
{
	idt[num].low = ((uint) func & 0xffff) | (KERNEL_CODE_DES << 16);
	idt[num].high = 0x8000 | ((uint) func & 0xffff0000) | flag;
}

/*
 * Set call gate discriptor
 * parameters : Value of discritor,Offset,Parameter count
 */
void set_gate(
	int des,
	void *addr,
	uchar para_num)
{
	gdt[des / 8].low = ((uint) addr & 0xffff) | (KERNEL_CODE_DES << 16);
	gdt[des / 8].high = ((uint) addr & 0xffff0000) | 0xec00 | para_num;
}

//*************************************************************************************************

int testIntr(void *func)
{
	printk("callUserHandler() 0x%x", func);
	callUserHandler(func, 5);
	printk("end\n");
//	printk("callUserFunc()=%d\n", callUserFunc(func, 5, 4, 3, 2, 1));
	
	return 0;
}
