/*
 * interrupt.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * interrupt.S interrupt.c ѥإåե
 */


#ifndef interrupt_h
#define interrupt_h


#include <sys/types.h>
#include <machine/segment.h>
#include <kern/proc.h>
#include <kern/signal.h>


// IRQȥ꡼ơ֥
#define IRQ0			0
#define IRQ1			1
#define IRQ3			3
#define IRQ4			4
#define IRQ5			5
#define IRQ6			6
#define IRQ7			7
#define IRQ8			8
#define IRQ9			9
#define IRQ10			10
#define IRQ11			11
#define IRQ12			12
#define IRQ13			13
#define IRQ14			14
#define IRQ15			15
#define FLASH_PAGEDIR	16
#define APIC_TIMER		17


#ifndef ASM_FILE


enum{
	IRQ_ENTRY = APIC_TIMER + 1,	// IRQϥɥ饨ȥ꡼

	// IDT flag.
	IDT_INTR=0xe00,	// Intrrupt gate
	IDT_TRAP=0xf00,	// Trap gate
};

extern int (*irq_entry[])(int);
extern void (*irq_eoi)(uchar);
extern void (*release_irq_mask)(uchar);
extern void (*set_irq_mask)(uchar);
extern void set_idt(int,void*,int);
extern void set_gate(int,void*,uchar);


#endif


#endif
