/*
 * lib_i386.S
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ֥롼饤֥꡼
 */


#define ASM_FILE


#include <machine/segment.h>


.text


/*
 * TSSǥץ
 * void loadTss(const int);
 */
.globl loadTss
loadTss:
	movl	4(%esp), %eax
	ltr		%ax
	ret

/*
 * void idle();
 * ɥ롼
 */
.globl idle
idle:
	hlt
	jmp		idle


/*
 * ֤ : å
 * long long rdtsc()
 */
.globl rdtsc
rdtsc:
	rdtsc
	ret


/*
 * void fpuSave(uchar *)
 */
.globl fpuSave
fpuSave:
	movl	4(%esp), %eax
	fnsave	(%eax)
	ret


/*
 * void fpuStore(uchar *)
 */
.globl fpuStore
fpuStore:
	movl	4(%esp), %eax
	frstor	(%eax)
	ret


/*
 * ǥХԲ㳰
 * void setTs()
 */
.globl setTs
setTs:
	movl	%cr0, %eax
	orl		$0x8, %eax
	movl	%eax, %cr0
	ret


/*
 * ǥХԲ㳰ȥå
 * void clearTs()
 */
.globl clearTs
clearTs:
	movl	%cr0, %eax
	andl	$~0x8, %eax
	movl	%eax, %cr0
	ret

/*
 * CPUֹ
 * int getCpu()
 */
.globl getCpu
getCpu:
	xorl	%eax, %eax
	str		%ax
	subl	$TSS_DES, %eax
	shrl	$3, %eax
	ret

// uint getFualtAddr()
.globl getFualtAddr
getFualtAddr:
	movl	%cr2, %eax	// եɥ쥹
	ret


/*
 * Сåפʤԡ
 * P6ץåξ硢ɥ쥹8Хȶ256ХȰʾΥԡʤ®ǥԡ
 * void *memcpy(void *dest,const void *src, size_t n);
 */
.globl memcpy
memcpy:
	pushl	%esi
	pushl	%edi
	movl	12(%esp), %edi
	movl	16(%esp), %esi
	cmpl	%esi, %edi
	je		1f

	/* Adjust alignment by 4bytes */
	xorl	%ecx, %ecx
	subl	%esi, %ecx
	andl	$0x3, %ecx
	cmpl	20(%esp), %ecx
	ja		2f
	movl	%ecx, %eax
	rep
	movsb

	/* Move by 4bytes */
	movl	20(%esp), %ecx
	subl	%eax, %ecx
	movl	%ecx, 20(%esp)
	shrl	$2, %ecx
	rep
	movsl

	/* Move rest by bytes */
2:	movl	20(%esp), %ecx
	andl	$0x3, %ecx
	rep
	movsb

1:	movl	12(%esp), %eax
	popl	%edi
	popl	%esi
	ret


/*
 * Сåפ륳ԡ
 * void memCpyBack(void *dest,const void *src, size_t n);
 */
.globl memCpyBack
memCpyBack:
	pushl	%esi
	pushl	%edi
	movl	12(%esp), %edi
	movl	16(%esp), %esi
	movl	20(%esp), %ecx
	std

	addl	%ecx, %edi
	addl	%ecx, %esi
	decl	%edi
	decl	%esi
	rep
	movsb

	cld
	popl	%edi
	popl	%esi
	ret


/*
 * P6ץåξ硢ɥ쥹8Хȶ256ХȰʾΥԡʤ®ǥԡ
 * void *memset(void *dest,int c,size_t n);
 */
.globl memset
memset:
	pushl	%edi
	movl	8(%esp), %edi
	movl	12(%esp), %eax
	movl	16(%esp), %ecx
	orl		%ecx, %ecx
	je		1f

	/* Adjust alignment by 8bytes */
	xorl	%ecx, %ecx
	subl	%edi, %ecx
	andl	$0x7, %ecx
	cmpl	16(%esp), %ecx
	ja		2f
	movl	%ecx, %edx
	rep
	stosb

	/* Store by 4bytes */
	movb	%al, %ah
	movl	%eax, %ecx
	shll	$16, %eax
	orl		%ecx, %eax
	movl	16(%esp), %ecx
	subl	%edx, %ecx
	movl	%ecx, 16(%esp)
	shrl	$2, %ecx
	rep
	stosl

	/* Store rest by bytes */
2:	movl	16(%esp), %ecx
	andl	$0x3, %ecx
	rep
	stosb

1:	movl	12(%esp), %eax
	popl	%edi
	ret

/*
 * ߶ػ
 * void cli()
 */
.globl cli
cli:
	cli
	ret

/*
 * ߲
 * void sti()
 */
.globl sti
sti:
	sti
	ret

/*
 * ߶ػ
 * int enterCli()
 * return : eflags
 */
.globl enterCli
enterCli:
	pushfl
	popl	%eax
	cli
	ret

/*
 * ¸Ƥeflagsγߥե饰᤹
 * void exitCli(int)
 */
.globl exitCli
exitCli:
	movl	4(%esp), %eax
	andl	$0x200, %eax		// ߥե饰Ф
	pushfl
	popl	%edx
	orl		%eax, %edx
	pushl	%edx
	popfl
	ret

/*
 * ԥå
 * void enter_spinlock(int *gate)
 */
.globl enter_spinlock
enter_spinlock:
	movl	4(%esp), %eax		// gateɥ쥹

1:	cmpl	$0, (%eax)			// gate0ˤʤޤǥ롼
	jne		1b

	movl	$1, %edx
	xchgl	%edx, (%eax)
	cmpl	$0, %edx
	jne		1b

	ret

/*
 * ԥå
 * void exit_spinlock(int *gate)
 */
.globl exit_spinlock
exit_spinlock:
	movl	4(%esp), %eax		// gateɥ쥹
	movl	$0, (%eax)
	ret


/*
 * ꥢ⡼ɤ˰ܹԤƻΥɥ쥹إפ롣
 *եץɥ쥹0x10000̤Ǥ뤳
 * void switchRealMode(void *jumpAddr);
 */
.globl switchRealMode
switchRealMode:
	movl	4(%esp), %eax
	movw	%ax, jumpOffset

	call	storeRealIdt
	cli
	lidt	realIdtr

/* Flash TLB. */
	movl	%cr0, %eax
	andl	$0x7fffffff, %eax
	movl	%eax, %cr0
	xorl	%eax, %eax
	movl	%eax, %cr3


/* ꥢ⡼ѥȤΥɡ */
	movl	$REAL_DATA_DES, %eax
	movl	%eax, %ss
	movl	%eax, %ds
	movl	%eax, %es
	movl	%eax, %fs
	movl	%eax, %gs
	ljmp	$REAL_CODE_DES, $realMode

.code16
realMode:
	movl	%cr0, %eax
	andl	$0xfffffffe, %eax
	movl	%eax, %cr0
	wbinvd
	movw	$REAL_SS_SEG, %ax
	movw	%ax, %ss
	movw	$REAL_SP_REG, %sp
	sti

	jmp		*jumpOffset

.globl jumpToBios
jumpToBios:
	ljmp	$0xffff, $0


jumpOffset:
	.word	jumpToBios


.data


/* ꥢ⡼IDTR. */
realIdtr:
	.word	0x3ff
	.long	0
