/*
 * mode_switch.S
 *
 * Copyright 2006, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *Գסճߡø桼⡼ɴܥ֥롼
 */


#define ASM_FILE


#include <sys/config.h>
#include <sys/param.h>
#include <sys/errno.h>
#include <kern/mm.h>
#include <machine/interrupt.h>
#include <machine/segment.h>
#include <machine/vm.h>


/****************************************************************************
 *
 * ޥ
 *
 ****************************************************************************/

.macro SAVE_TRAP
	pushl	$0				// 顼
	SAVE
.endm

// ƥȥ֤ѹϡproc.cset_context()˱ƶ롣
.macro SAVE
	pushal
	pushl	%es
	pushl	%ds
/*	pushl	%fs
	pushl	%gs*/
	movl	$KERNEL_DATA_DES, %eax
	movl	%eax, %es
	movl	%eax, %ds
	cld
.endm

.macro SWITCH
	pushl	$0				// ͥȳ߻γ߻espͤ¸ȤʤΤǤȤꤢ롣
	pushl	%esp			// "switch_task"ȼΥespͤäɥ쥹ꤵ롣
	cli						// ɥ쥹֤Ѥޤǳߤػߤ롣
	call	switch_task
	popl	%edx			// Υespͤäɥ쥹
	movl	(%edx), %esp
	movl	%eax, %cr3		// Υβۥ꡼֤˰ܹԤ롣
	sti
	popl	%eax
	movl	%eax, (%edx)	// ͥȳ߻γespͤäesp¸ΰ¸롣

	call	setTs			// FPUԲ㳰Ĥˤ
.endm

.macro RESTORE
/*	popl	%gs
	popl	%fs*/
	popl	%ds
	popl	%es
	popal
	addl	$4, %esp		// 顼ʬ
	iret
.endm

.macro EXCEPT handler
	SAVE
	call	calcProcUserTime
	call	setProcCurrentTime
	call	incrementNest
	call	\handler

	call	doSignal
	call	calcProcSysTime
	call	decrementNest
	call	setProcCurrentTime
	RESTORE
.endm

.macro TRAP irq, handler
	SAVE_TRAP
	call	calcProcUserTime
	call	setProcCurrentTime
	call	incrementNest

	pushl	$\handler
	call	*irq_entry + \handler * 4
	addl	$4, %esp

	pushl	%eax

	pushl	$\irq
	call	*irq_eoi
	addl	$4,%esp

	call	doSignal
	call	calcProcSysTime
	call	decrementNest

	popl	%eax
	cmpl	$YES, %eax
	jne		1f

	SWITCH
1:
	call	setProcCurrentTime
	RESTORE
.endm

// աѹ"SYSCALL_PARAM""SYSCALL*_FRAME"ѹɬ
.macro SAVE_SYSCALL
	pushl	%ds
	pushl	%es
	movl	$KERNEL_DATA_DES,%edx
	movl	%edx,%ds
	movl	%edx,%es
	cld

	pushl	%eax
	call	calcProcUserTime
	call	setProcCurrentTime
	call	incrementNest
	popl	%eax
#ifdef DEBUG
	pushl	%eax
	pushl	syscall_table(,%eax,4)
	call	saveSyscallEntry
	addl	$4, %esp
	popl	%eax
#endif
.endm

.macro RESTORE_SYSCALL
	pushl	%eax
	call    doSignal
	call	calcProcSysTime
	call	decrementNest
	call	setProcCurrentTime
	popl	%eax

	popl	%es
	popl	%ds
.endm


.text

/****************************************************************************
 *
 * 㳰
 *
 ****************************************************************************/

.globl except0
except0:
	pushl	$0
	EXCEPT excDivideError

.globl except1
except1:
	pushl	$0
	SAVE
	call	debug
	RESTORE

.globl except2
except2:
	pushl	$0
	EXCEPT excNonmaskableInterrupt

.globl except3
except3:
	pushl	$0
	EXCEPT excBreakpoint

.globl except4
except4:
	pushl	$0
	EXCEPT excOverflow

.globl except5
except5:
	pushl	$0
	EXCEPT excBoundsCheck

.globl except6
except6:
	pushl	$0
	EXCEPT excInvalidOpcode

.globl except7
except7:
	pushl	$0
	EXCEPT excCoprocessorNotAvailable

.globl except8
except8:
	EXCEPT excDoubleFault

.globl except9
except9:
	pushl	$0
	EXCEPT excCopressorOverrun

.globl except10
except10:
	EXCEPT excInvalidTss

.globl except11
except11:
	EXCEPT excSegmentNotPresent

.globl except12
except12:
	EXCEPT excStackException

.globl except13
except13:
	EXCEPT excGeneralProtection

.globl except14
except14:
	// 桼襢ɥ쥹
	cmpl	$0, %ss:KERNEL_RET_USER
	je		next
	pushl	%edx
	movl	%cr2, %edx	// եɥ쥹
	cmpl	%ss:KERNEL_RET_USER, %edx
	popl	%edx
	jne		next
	jmp		%ss:*KERNEL_RET_USER
next:
	EXCEPT pageFault

.globl except15
except15:
	pushl	$0
	EXCEPT excReserve

.globl except16
except16:
	pushl	$0
	EXCEPT excFpuError

.globl except17
except17:
	EXCEPT excAlignmentCheck

.globl except18
except18:
	pushl	$0
	EXCEPT excMachineCheck

.globl except19
except19:
	pushl	$0
	EXCEPT excSimdFpuError

/****************************************************************************
 *
 * ǥХ
 *
 ****************************************************************************/

.globl apictimer
apictimer:
	TRAP 0,APIC_TIMER

.globl irq0
irq0:
	TRAP 0,IRQ0

.globl irq1
irq1:
	TRAP 1,IRQ1

.globl irq3
irq3:
	TRAP 3,IRQ3

.globl irq4
irq4:
	TRAP 4,IRQ4

.globl irq5
irq5:
	TRAP 5,IRQ5

.globl irq6
irq6:
	TRAP 6,IRQ6

.globl irq7
irq7:
	TRAP 7,IRQ7

.globl irq8
irq8:
	TRAP 8,IRQ8

.globl irq9
irq9:
	TRAP 9,IRQ9

.globl irq10
irq10:
	TRAP 10,IRQ10

.globl irq11
irq11:
	TRAP 11,IRQ11

.globl irq12
irq12:
	TRAP 12,IRQ12

.globl irq13
irq13:
	TRAP 13,IRQ13

.globl irq14
irq14:
	TRAP 14,IRQ14

.globl irq15
irq15:
	TRAP 15,IRQ15

.globl flash_pagedir
flash_pagedir:
	TRAP 0,FLASH_PAGEDIR


/****************************************************************************
 *
 * ƥॳ
 *
 ****************************************************************************/

#define SYSCALL_PARAM 20	// ƥॳѥ᡼

.globl syscall0
syscall0:
	SAVE_SYSCALL
	call	*syscall_table(,%eax,4)
	RESTORE_SYSCALL
	lret	$4*1

.globl syscall1
syscall1:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM(%esp),%edx
	pushl	%edx
	call	*syscall_table(,%eax,4)
	addl	$4*1,%esp
	RESTORE_SYSCALL
	lret	$4*2

.globl syscall2
syscall2:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM + 4(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 4(%esp),%ecx
	pushl	%ecx
	call	*syscall_table(,%eax,4)
	addl	$4*2,%esp
	RESTORE_SYSCALL
	lret	$4*3

.globl syscall3
syscall3:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM + 8(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 8(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 8(%esp),%edx
	pushl	%edx
	call	*syscall_table(,%eax,4)
	addl	$4*3,%esp
	RESTORE_SYSCALL
	lret	$4*4

.globl syscall4
syscall4:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM + 12(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 12(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 12(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 12(%esp),%ecx
	pushl	%ecx
	call	*syscall_table(,%eax,4)
	addl	$4*4,%esp
	RESTORE_SYSCALL
	lret	$4*5

.globl syscall5
syscall5:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM + 16(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 16(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 16(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 16(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 16(%esp),%edx
	pushl	%edx
	call	*syscall_table(,%eax,4)
	addl	$4*5,%esp
	RESTORE_SYSCALL
	lret	$4*6

.globl syscall6
syscall6:
	SAVE_SYSCALL
	movl	SYSCALL_PARAM + 20(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 20(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 20(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 20(%esp),%ecx
	pushl	%ecx
	movl	SYSCALL_PARAM + 20(%esp),%edx
	pushl	%edx
	movl	SYSCALL_PARAM + 20(%esp),%ecx
	pushl	%ecx
	call	*syscall_table(,%eax,4)
	addl	$4*6,%esp
	RESTORE_SYSCALL
	lret	$4*7


/****************************************************************************
 *
 * ץؿ
 *
 ****************************************************************************/

/*
 * void wait_task()
 */
.globl wait_task
wait_task:
	// åΥƥȤ
	popl	%eax				// ƤӽФeip
	pushfl
	orl		$0x200, (%esp)		// äƤȤ߲Ĥˤ
	pushl	$KERNEL_CODE_DES
	pushl	%eax

	SAVE_TRAP
	SWITCH
	RESTORE


/*
 *ճ߶ػߤƤ뤳
 * sys_exitؿ
 * Υ˥åͥڡȥڡǥ쥯ȥ롣
 * void returnExit(uint *)
 * parameters : ڡǥ쥯ȥ
 */
.globl returnExit
returnExit:
	movl	4(%esp),%ebp	/* memory struct address. */
	// ڡ˥åƤ
	pushl	$0				/* γ߻espͤ¸ */
	pushl	%esp			/* espͤ͡ϼΥesp¸ɥ쥹 */
	call	switch_task
	popl	%edx			/* ƥȤ֤줿åΥȥåesp */
	movl	(%edx),%esp
	movl	%eax,%cr3		/* ΥΥڡǥ쥯ȥ */
	popl	%eax			/* γ߻esp */
	movl	%eax,(%edx)
	pushl	%ebp

	// ڡ
	call	releasePageDir
	addl	$4,%esp
	RESTORE

/*
 * uint setChildContext(
 *	void*);				// ҥץͥ륹åʪɥ쥹
 * forkλҥץΥƥȤۤ롣
 * ҥץϤδؿ꤫鳫Ϥ롣
 * ƥȤϡinterrupt.SΥƥ¸ɤ˰¸롣
 * return : ҥץΥƥȥåesp͡ҥץʤ0
 */
.globl setChildContext
setChildContext:
	// åƤҥåإԡ
	movl	$KERNEL_END, %eax
	subl	%esp, %eax				// ԡ
	movl	4(%esp), %edx			// ҥץåѥ꡼
	addl	$PAGE_SIZE, %edx
	subl	%eax, %edx				// ԡ襢ɥ쥹
	movl	%esp, %ecx
	pushl	%eax
	pushl	%ecx
	pushl	%edx
	call	memcpy
	addl	$12, %esp

	// espҥץå꡼
	movl	%esp, %edx				// setChildContextƤӽФesp
	addl	$4, %edx				// setChildContextƤӽФesp
	andl	$0xfff, %edx
	movl	4(%esp), %eax			// ҥץåѥ꡼
	orl		%edx, %eax
	movl	%esp, %ecx				// esp¸
	movl	%eax, %esp

	// ƥȤ
	pushfl
	pushl	%cs
	pushl	(%ecx)					// setChildContexteip
	xorl	%eax, %eax				// ҥץ꥿ = 0
	SAVE_TRAP
	pushl	$0						// before_esp

	// ҥץΥƥȥåespͤ׻
	movl	%esp, %eax
	andl	$0xfff, %eax
	addl	$(KERNEL_END - PAGE_SIZE), %eax

	movl	%ecx, %esp				// esp᤹
	ret

/*
 * 桼ʥϥɥƤӽФ
 * int callUserHandler(
 * 	const void *funcAddr,		// 桼ɥ쥹	4
 * 	const int param1)			// ʥֹ			8
 */
.globl callUserHandler
callUserHandler:
	movl	%esp, %ecx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	movl	%ecx, %ebp					// ƤӽФesp

	// 桼襢ɥ쥹
	movl	$returnUserHandler, KERNEL_RET_USER

	// 桼å˥ѥ᡼ꤹ
	call	getUserEsp
	movl	%esp, %ecx
	cli
	movl	%eax, %esp
	pushl	8(%ebp)						// ʥֹ
	pushl	$returnUserHandler			// ꥢɥ쥹
	movl	%esp, %esi					// user esp
	movl	%ecx, %esp
	sti

	/*
	 * ͥ륹å촹
	 */
	call	getStackPageEntry
	movl	%eax, %edi					// åڡȥ꡼ɥ쥹
	movl	(%eax), %ecx				// åڡȥ꡼
	movl	%ecx, KERNEL_SAVE_PENT		// 쥹åڡȥ꡼¸

	call	allocKernelPage
	cmpl	$0, %eax
	je		allocError
	movl	%eax, %ebx					// å꡼

	// åƤ򥳥ԡ
	movl	$KERNEL_END, %eax
	subl	%esp, %eax					// ԡ

	movl	%ebx, %edx					// å꡼
	addl	$PAGE_SIZE, %edx
	subl	%eax, %edx					// ԡ襢ɥ쥹
	movl	%esp, %ecx					// ԡɥ쥹
	pushl	%eax
	pushl	%ecx
	pushl	%edx
	call	memcpy
	addl	$12, %esp

	// ͥ륹åڡȥ꡼촹
	movl	%ebx, %eax
	orl		$(PAGE_PRESEN | PAGE_RW), %eax	// 촹åڡȥ꡼

	// ۥ꡼֤򥹥å
	cli
	movl	%eax, (%edi)
	call	getPageDir					// eax = ڡǥ쥯ȥꥢɥ쥹
	movl	%eax, %cr3
	sti

	movl	%esp, KERNEL_SAVE_ESP		// å촹Ƭå

	// ǥХԲ㳰
	call	setTs

	// å˥桼ƥȤꤹ
	pushl	$USER_DATA_DES				// user ss
	pushl	%esi						// user esp
	pushl	$USER_CODE_DES				// user cs
	pushl	4(%ebp)						// user eip

	// 桼˰ܹ
	movl	$USER_DATA_DES, %edx
	movl	%edx, %ds
	movl	%edx, %es
	lret

allocError:
	movl	$-ENOMEM, %eax
	jmp		endRetern

/*
 * 桼ʥϥɥ餫
 * 桼Υåξ
 *	桼ss			// 20
 *	桼esp			// 16
 *	桼eflags		// 12
 *	桼cs			// 8
 *	桼eip 		// 4
 *	顼		// 0
 */
returnUserHandler:
	sti
	movl	$KERNEL_DATA_DES, %edx
	movl	%edx, %ds
	movl	%edx, %es
	cld

	// 桼ꥢɥ쥹ݥ󥿤Υꥻå
	movl	$0, KERNEL_RET_USER

	// FPU֥ɥ쥹򥯥ꥢ
	call	clearFpuSaveAddr

	/*
	 * ͥ륹å᤹
	 */
	call	getStackPageEntry			// eax = åڡȥ꡼ɥ쥹
	movl	(%eax), %ebx				// 촹åڡȥ꡼
	andl	$~0xfff, %ebx				// åɥ쥹Ф
	movl	KERNEL_SAVE_PENT, %ecx		// 쥹åڡȥ꡼

	// ۥ꡼֤򥹥å
	cli
	movl	%ecx, (%eax)				// åڡȥ꡼᤹
	movl	KERNEL_SAVE_ESP, %esp		// å촹Ƭå
	call	getPageDir					// eax = ڡǥ쥯ȥꥢɥ쥹
	movl	%eax, %cr3
	sti

	pushl	%ebx
	call	unlinkPhysTable				// 촹å꡼
	addl	$4, %esp

	// ǥХԲ㳰
	call	setTs

	movl	$0, %eax
endRetern:
	// callUserHandlerƤӽФ
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ebp
	ret

/*
 * 桼ƤӽФ
 * uint callUserFunc(
 * 	const void *funcAddr,	// 桼ɥ쥹	4
 * 	uint param1,			// 				8
 * 	uint param2,			// 						12
 * 	uint param3,			// 						16
 * 	uint param4,			// 						20
 * 	uint param5)			// 						24
 * return : 
 */
.globl callUserFunc
callUserFunc:
	movl	%esp, %ecx
	pushl	%ebp
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	movl	%ecx, %ebx			// ƤӽФesp

	// 桼襢ɥ쥹
	movl	$returnUserFunc, KERNEL_RET_USER

	// 桼å˥ѥ᡼ꤹ
	call	getUserEsp
	movl	%esp, %ebp
	cli
	movl	%eax, %esp
	pushl	24(%ebx)			// param5
	pushl	20(%ebx)			// param4
	pushl	16(%ebx)			// param3
	pushl	12(%ebx)			// param2
	pushl	8(%ebx)				// param1
	pushl	$returnUserFunc		// ꥢɥ쥹
	movl	%esp, %esi			// user esp
	movl	%ebp, %esp
	sti

	// å˥桼ƥȤꤹ
	pushl	$USER_DATA_DES		// user ss
	pushl	%esi				// user esp
	pushl	$USER_CODE_DES		// user cs
	pushl	4(%ebx)				// user eip

	// 桼˰ܹ
	movl	$USER_DATA_DES, %edx
	movl	%edx, %ds
	movl	%edx, %es
	lret

/*
 * 桼
 * 桼Υåξ
 *	桼ss			// 20
 *	桼esp			// 16
 *	桼eflags		// 12
 *	桼cs			// 8
 *	桼eip 		// 4
 *	顼		// 0
 */
returnUserFunc:
	sti
	movl	$KERNEL_DATA_DES, %edx
	movl	%edx, %ds
	movl	%edx, %es
	cld

	// esp桼ܹ24 + 桼ƥ16᤹
	addl	$40, %esp
	
	// 桼ꥢɥ쥹ݥ󥿤Υꥻå
	movl	$0, KERNEL_RET_USER

	pushl	%eax			// 桼ֵͤ¸

	popl	%eax			// 桼ֵ᤹ͤ

	// callUserFuncƤӽФ
	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%ebp
	ret
