/*
 * mode_switch.h
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef mode_switch_h
#define mode_switch_h


#ifndef ASM_FILE


// O荞݃X^bNt[
typedef struct{
/*	uint gs;
	uint fs;*/
	uint ds;
	uint es;
	uint edi;
	uint esi;
	uint ebp;
	uint esp;
	uint ebx;
	uint edx;
	uint ecx;
	uint eax;
	uint error;
	uint eip;
	uint cs;
	uint eflags;
	uint user_esp;
	uint user_ss;
} INTERRUPT_FRAME;

// VXeR[X^bNt[
typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[1];
	uint user_esp;
	uint ss;
} SYSCALL1_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[2];
	uint user_esp;
	uint ss;
}SYSCALL2_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[3];
	uint user_esp;
	uint ss;
}SYSCALL3_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[4];
	uint user_esp;
	uint ss;
}SYSCALL4_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[5];
	uint user_esp;
	uint ss;
}SYSCALL5_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[6];
	uint user_esp;
	uint ss;
}SYSCALL6_FRAME;

typedef struct{
	uint es;
	uint ds;
	uint eip;
	uint cs;
	uint para[7];
	uint user_esp;
	uint ss;
}SYSCALL7_FRAME;

extern void except0();
extern void except1();
extern void except2();
extern void except3();
extern void except4();
extern void except5();
extern void except6();
extern void except7();
extern void except8();
extern void except9();
extern void except10();
extern void except11();
extern void except12();
extern void except13();
extern void except14();
extern void except15();
extern void except16();
extern void except17();
extern void except18();
extern void apictimer();
extern void irq0();
extern void irq1();
extern void irq2();
extern void irq3();
extern void irq4();
extern void irq5();
extern void irq6();
extern void irq7();
extern void irq8();
extern void irq9();
extern void irq10();
extern void irq11();
extern void irq12();
extern void irq13();
extern void irq14();
extern void irq15();
extern void flash_pagedir();
extern int syscall0();
extern int syscall1();
extern int syscall2();
extern int syscall3();
extern int syscall4();
extern int syscall5();
extern int syscall6();
extern void wait_task();
extern void returnExit(void*);
extern uint setChildContext(void*);
extern int callUserHandler(const void *, const int);
extern uint callUserFunc(const void *, uint, uint, uint, uint, uint);


#endif


#endif
