/*
 * debug.h
 *
 * Copyright 2004, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef debug_h
#define debug_h


#ifndef ASM_FILE


#ifdef DEBUG
 #define ASSERT(bool) if ((bool) == 0){							\
 	printk("Assertion! : %s line=%d \n",__FILE__, __LINE__); 	\
 	idle();														\
 }
 #define WARNING(bool) if ((bool) == 0){						\
 	printk("Warning! : %s line=%d \n",__FILE__, __LINE__);		\
 }
#else
 #define ASSERT(bool)
 #define WARNING(bool)
#endif

extern int debugFlag;
extern void saveSyscallEntry(uint, int);
extern void printSyscallEntry(uint);

#ifdef DEBUG

extern void displayTop(int, const char*, int);
extern void saveLog(const int, const int, void *, ...);
extern void printLog(const int dataNum, const int logNum, void *m_logBuf);

extern void test_console();
extern void test_fd();
extern void test_com();
extern void test_time(int);
extern dev_t test_device(int);
extern void testFs();
extern void test_orig_fs();
extern void test_fatFs();
extern void test_elf(void*);
extern int test_ext2(int);
extern int volatile test_mmFlag;
extern int test_mm(uint);
extern void test_pci();
extern int test_arp();
extern void test_tcp();
extern void test_mp();
extern void testSignal();
extern void test_freebsd();
extern void testPcibus(const int);
extern int testDisplay(int num);
extern void lockTest(void *i_proc, int cnt, void*);
extern void test_mbuf(uint, uint);
extern void test_ata();
extern int testIntr();
extern int testIntr();
extern void testSyscall();
extern void testLock();
extern void test_proc(int);
extern void test_debug(const uint);


#endif


#endif


#endif
