/*
 * lib_path.c
 *
 * Copyright 2005, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ѥʸؿ
 */


#include <sys/param.h>
#include <sys/types.h>
#include <kern/fs.h>


// ʸӤפХȿ֤
// ɤ餫NULLʸǤ⽪
int cmpStrNum(const char *dstStr, const char *srcStr)
{
	int count;

	for (count = 0; dstStr[count] & srcStr[count]; ++count) {
		if (dstStr[count] != srcStr[count]) {
			break;
		}
	}

	return count;
}

/*
 * ̾ʸȥѥʸӤ롣
 * parameters : destination name string,sorce path string,ӥХȿ
 * return : =0 or 礭=1 or =-1
 */
int cmpPath(const char *name,const char *path,int count)
{
	int i;

	for (i = 0; i < count; ++i){
		if (name[i] != path[i]){
			if ((uchar)name[i] > (uchar)path[i]){
				return 1;
			}
			else{
				return -1;
			}
		}
	}

	if ((path[count] == '/') || (path[count] == '\0')){
		return 0;
	}

	return -1;
}

/*
 * ѥʸ󥵥Ϥ롣
 * parmeters : path
 */
size_t pathLen(const char *path)
{
	const char *p=path;

	while (*p++ != '/'){
		if (*p == '\0'){
			return (size_t)(p-path);
		}
	}

	return (size_t)(p-path-1);
}

/*
 * ѥ饹ȥѥɤȽꤹ롣
 * return : YES or NO
 */
int isLastPath(const char *i_path)
{
	const char *path;

	for (path = i_path; *path != '\0'; ++path){
		if (*path == '/') {
			while (*++path == '/');
			break;
		}
	}

	return (*path == '\0') ? YES : NO;
}

/*
 * Υѥȥ꡼̾Ƭݥ󥿤롣
 * return : ѥȥ꡼̾Ƭݥ
 */
const char *getNextPath(
	const char *i_path)
{
	const char *path = i_path;

	for (; *path != '\0'; ++path) {
		if (*path == '/') {
			for (; *path == '/'; ++path);
			break;
		}
	}

	return path;
}

/*
 * Υѥȥ꡼̾Ƭݥ󥿤롣
 * return : ѥȥ꡼̾Ƭݥ
 */
static const char *getPrevPath(
	const char *i_path,
	const char *topPath)	// ѥγϥݥ
{
	const char *path = i_path;

	for (; *path == '/'; --path) {
		if (path == topPath) {
			return path;
		}
	}
	do {
		if (path == topPath) {
			return path;
		}
	} while (*--path != '/');

	return path + 1;
}

/*
 * ѥȥ꡼̾򥳥ԡ롣
 * return : ԡХȿ
 */
static int copyPath(
	const char *fromPath,	// ԡѥ
	char *i_toPath)			// ԡѥ
{
	char *toPath = i_toPath;
	int i;
	
	for (i = 0; fromPath[i] != '/'; ++i) {
		*toPath++ = fromPath[i];
		if (fromPath[i] == '\0') {
			return i;
		}
	}
	for (; fromPath[i] == '/'; ++i) {
		*toPath++ = '/';
	}

	return i;
}
