/*
 * mm.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * mm.c ѥإåե
 */


#ifndef mm_h
#define mm_h


#include<sys/types.h>
#include"proc.h"
#include"fs.h"


#ifndef ASM_FILE


enum{
	/* loadBinary() flag. */
	LB_R=1,
	LB_WR=2,
};


typedef struct{
	uint *pageDir;
	int pageDirGate;		/* ڡǥ쥯ȥåȡ */
	uint lastPageAddr;		/* ƺѤߥڡ饹ȥɥ쥹 */
	uint firstStackAddr;	/* ѤߥåƬɥ쥹 */
}MM_STRUCT;

/*
 * ꡼¤
 */
typedef struct{
	const int dummy;
}MEM_ARRAY;

/*
 * ꡼ס
 */
#define SET_MEMPOOL(name, max, memSize) 									\
	char mempoolArea[max * sizeof(void*) + sizeof(struct mempool)];			\
	struct mempool *name = (struct mempool*)mempoolArea;					\
	memset(mempoolArea, 0, max * sizeof(void*) + sizeof(struct mempool));	\
	name->maxCount = max;													\
	name->size = memSize;

struct mempool {
	size_t	size;			// Ƥ꡼
	int		maxCount;		// ꡼󥿡ʽ
	int		allocCount;		// 󥿡ʿʳ˥ץ饹
	int		currentCount;	// ꡼󥿡ʽͣưŪ
	void	*pointer[0];	// ¸꡼ݥ
};

extern void *allocKernelPage();
extern void unlinkPhysTable(void *);
extern void *kmallocSize(const uint, uint *);
extern void *kmalloc(size_t);
extern uint kfree(void*);
extern MEM_ARRAY *allocArray(size_t);
extern void freeArray(MEM_ARRAY *);
extern MEM_ARRAY *reallocArray(MEM_ARRAY *,size_t);
extern int writeArray(MEM_ARRAY *,const int,const size_t,const void *);
extern void copyArray(MEM_ARRAY *,const int,const size_t,void *);
extern int initBackupDev(const char*);
extern void updateVm();
extern uint getLastLinearAddr();
extern int checkMem(const void*,size_t);
extern void initMm();
extern void *initPaging();
extern int forkPage(MM_STRUCT*, int, void**, void**);
extern int loadBinary(EXEC_FD*,size_t,size_t,uint,int);
extern int setUserStack(char**, char**, uint*);
extern void releaseUserPage();
extern uint *getPageDir();
extern uint getPhysicalFromLogicalAddr(PROC*, uint);
extern uint addUserStack(int);
extern void delAddedUserStack();
extern int sys_brk(void*);
extern uint getMaxMemory();
extern void *getMempool(struct mempool *, int *);
extern void releaseMempool(void *, struct mempool *);
extern void freeMempool(const struct mempool *);


#endif


#endif
