/*
 * proc.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ץطإåե
 */


#ifndef proc_h
#define proc_h


#include <sys/types.h>
#include <sys/wait.h>
#include <machine/fpu.h>
#include <machine/segment.h>
#include <kern/timer.h>
#include <kern/List.h>
#include <kern/AggregateList.h>


#ifndef ASM_FILE


enum{
	MAX_CHILD = 8,		/* Max number of child processes */

	/* ץξ֡ */
	TASK_RUNNING =		1 << 0,
	TASK_WAIT =			1 << 1,
	TASK_DEVICE_WAIT =	1 << 2,		// ǥХԤ
	TASK_SIGNAL_WAIT =	1 << 3,		// ʥԤ
	TASK_SIGNAL_STOP =	1 << 4,		// ʥˤ
	TASK_TRACE =		1 << 5,		// ȥ졼
	TASK_EXIT =			1 << 6,		// Exit
	TASK_CHILD_WAIT =	1 << 7,		// wait callԤ
};

/*
 * ץ¤
 */
struct proc{
	List			list;				// 塼ѥꥹ
	List			waitList;			// ѥꥹ
	struct proc		*proc_next;			// ץꥹ
	struct proc		*proc_prev;			// ץꥹ
	struct proc		*parent;			// Parent process.
	struct proc		*brother;			// Brother process
	uchar			state;				// ץξ֡
#define PROC_ZERO_TOP child				// 0λϤǡ
	struct proc		*child;				// Child process
	char			nestCount;			// ߥͥȥ
	uchar		 	count_child;		// Number of child processes
	uchar		 	exit_state;			// Exit state.
	uchar		 	signum;				// Exit signal number.

	// ץ
	uint64		 	sysClocks;			// ץƥвCPUå
	uint64		 	userClocks;			// ץ桼вCPUå
	uint		 	ctime[2];			// ҥץ׻ system = 0,user = 1
	uint64			beforeClocks;		// ץַ¬ѵCPUå
//	int fpuFlag;
#define PROC_ZERO_END cpu				// 0κǸμǡ
	uchar			cpu;				// running cpu number ƯƤʤ-1ʲ
	uint			esp;				// ֤ƥȤΥåȥåesp

	pid_t			pid;				// process ID.
	pid_t			pgid;				// process groupe ID.
	uid_t			uid;				// user ID.
	gid_t			gid;				// user groupe ID.
	pid_t			sid;				// session ID.

	// ޡ
	TIMER_OWNER		procTimer;			// ץݻޡ
	ITIMER			itimer[ITIMER_MAX];	// itimer

	// ߥʥ
	void			*ctlterm;			// ߥʥ湽¤Ρ

	// ʥ
	void			*signal_struct;		// ʥ¤Ρ

	// ꡼
	void			*mm_struct;			// ꡼¤Υɥ쥹

	// ե
	void			*file_struct;		// ե빽¤Υɥ쥹

	int				gate;				// ԥå
};

typedef struct proc PROC;

/* ץꥹȹ¤Ρ */
typedef struct PROC_LIST{
	struct PROC_LIST *next;
	struct PROC_LIST *prev;
	int lockGate;
}PROC_LIST;

extern PROC_LIST PROCHash[];


#define getProcAddr(address,member) (PROC*)((uint)address-(uint)&((PROC*)0)->member)


extern PROC *get_current_task();
extern void addToSchedule(PROC*, const int);
extern void addScheduleSoon(PROC *, const int);
extern void delFromSchedule(const int);
extern void addScheduleSetFlag(PROC *, const int, int *);
extern void delFromScheduleByFlag(const int, int volatile *);

extern PROC *searchProcList(int);
extern void waitProc1();
extern void incrementNest();
extern void decrementNest();
extern int isNest();
extern int isSingleNest();
extern int forkKernelThread();
extern int initProc1();
extern int init_cputask(int);
extern int createIdleProc(int);
extern void start_tasking();
extern PROC *getNextProc(PROC*,int);
extern void sendSignalAllProc(int);
extern void exit(int,int);
extern int sys_fork();
extern int sys_exit();
extern int sys_exec();
extern int sys_wait();
extern int sys_getpid();
extern int sys_getgid();
extern int sys_getpgid();
extern int sys_getppid();
extern int sys_getuid();
extern int sys_getsid();
extern int sys_setgid();
extern int sys_setpgid();
extern int sys_setuid();
extern int sys_setsid();

extern int sys_times();


#endif


#endif
