/*
 * AggregateList.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *sTvt
 * Iteratorp^[ListIteratorpoXgB
 *
 *sOt
 * XVł̔r͌ĂяołsƁB
 */


#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include "IteratorList.h"
#include "AggregateList.h"
#include "test.h"


//================================== PRIVATE ============================================

/*
 * ڑvf̎ɐڑ
 */
STATIC INLINE void addNext(
	List *dst,
	List *src)
{
	src->next = dst->next;
	src->prev = dst;
	dst->next = src;
	if (src->next != NULL) {
		src->next->prev = src;
	}
}

/*
 * ڑvf̑Oɐڑ
 */
STATIC INLINE void addPrev(
	List *dst,		// ڑ惊Xgo[|C^
	List *src)		// ڑXgo[|C^
{
	src->next = dst;
	src->prev = dst->prev;
	dst->prev = src;
	if (src->prev != NULL) {
		src->prev->next = src;
	}
}

/*
 * Xg폜
 */
STATIC INLINE void erase(
	List *src)
{
	if (src->prev != NULL) {
		src->prev->next = src->next;
	}
	if (src->next != NULL) {
		src->next->prev = src->prev;
	}
	src->next =  NULL;
	src->prev = NULL;
}

//================================== PUBLIC =============================================

/*
 * Xgwb_ɐڑ
 *sOtڑXgGg[͏Ă邱
 */
STATIC void insertHead(
	AggregateList *this,
	List *m_list)
{
	ASSERT((m_list->next == NULL) && (m_list->prev == NULL));

	if (this->head == NULL) {
		this->head = m_list;
		this->end = m_list;
	}
	else {
		addPrev(this->head, m_list);
		this->head = m_list;
	}
}

/*
 * XgGhɐڑ
 *sOtڑXgGg[͏Ă邱
 */
STATIC void insertEnd(
	AggregateList *this,
	List *m_list)
{
	ASSERT((m_list->next == NULL) && (m_list->prev == NULL));

	if (this->end == NULL) {
		this->head = m_list;
		this->end = m_list;
	}
	else {
		addNext(this->end, m_list);
		this->end = m_list;
	}
}

/*
 * XgGg[̎ɐڑ
 */
STATIC void insertNext(
	AggregateList *this,
	List *m_dst,				// ڑGg[
	List *m_src)
{
	// ڑXgGg[͏Ă邱
	ASSERT((m_src->next == NULL) && (m_src->prev == NULL));

	addNext(m_dst, m_src);

	if (this->end == m_dst) {
		this->end = m_src;
	}
}

/*
 * XgGg[̑Oɐڑ
 */
STATIC void insertPrev(
	AggregateList *this,
	List *m_dst,				// ڑGg[
	List *m_src)
{
	// ڑXgGg[͏Ă邱
	ASSERT((m_src->next == NULL) && (m_src->prev == NULL));

	addPrev(m_dst, m_src);

	if (this->head == m_dst) {
		this->head = m_src;
	}
}

/*
 * XgGg[菜
 */
STATIC void removeEntry(
	AggregateList *this,
	List *m_list)
{
	// Gg[͐ڑĂ邱
	ASSERT(m_list != NULL);

	if (this->head == m_list) {
		if (this->end == m_list) {
			this->head = NULL;
			this->end = NULL;
		}
		else {
			this->head = m_list->next;
			erase(m_list);
		}
	}
	else if (this->end == m_list) {
		this->end = m_list->prev;
		erase(m_list);
	}
	else {
		erase(m_list);
	}
}

/*
 * wbhGg[o
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *getHead(
	AggregateList *this)
{
	if (this->head != NULL) {
		List *headEntry = this->head;
		removeEntry(this, headEntry);

		return headEntry->object;
	}
	else {
		return NULL;
	}
}

/*
 * GhGg[o
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *getEnd(
	AggregateList *this)
{
	if (this->end != NULL) {
		List *endEntry = this->end;
		removeEntry(this, endEntry);

		return endEntry->object;
	}
	else {
		return NULL;
	}
}

/*
 * ̃Gg[o
 * return : Gg[̏IuWFNg or NULL
 */
/*STATIC OBJECT *getNext(
	AggregateList *this,
	List *m_dst)
{
	List *nextEntry;

	// Gg[͐ڑĂ邱
	ASSERT(m_dst != NULL);
	ASSERT((m_dst->next != NULL) && (m_dst->prev != NULL));

	nextEntry = m_dst->next;
	if (nextEntry != NULL) {
		removeEntry(this, nextEntry);
		return nextEntry->object;
	}
	else {
		return NULL;
	}
}
*/
/*
 * ÕGg[o
 * return : Gg[̏IuWFNg or NULL
 */
/*STATIC OBJECT *getPrev(
	AggregateList *this,
	List *m_dst)
{
	List *prevEntry;

	// Gg[͐ڑĂ邱
	ASSERT(m_dst != NULL);
	ASSERT((m_dst->next != NULL) && (m_dst->prev != NULL));

	prevEntry = m_dst->prev;
	if (prevEntry != NULL) {
		removeEntry(this, prevEntry);
		return prevEntry->object;
	}
	else {
		return NULL;
	}
}
*/
/*
 * wbhGg[Q
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refHead(
	const AggregateList *this)
{
	if (this->head != NULL) {
		return this->head->object;
	}
	else {
		return NULL;
	}
}

/*
 * GhGg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refEnd(
	const AggregateList *this)
{
	if (this->end != NULL) {
		return this->end->object;
	}
	else {
		return NULL;
	}
}

/*
 * ̃Gg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refNext(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	if (i_dst->next != NULL) {
		return i_dst->next->object;
	}
	else {
		return NULL;
	}
}

/*
 * ÕGg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refPrev(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	if (i_dst->prev != NULL) {
		return i_dst->prev->object;
	}
	else {
		return NULL;
	}
}

//---------------------------- Ce[^[ ------------------------------------

STATIC IteratorList *iterator(
	AggregateList *this)
{
	IteratorListConstruct(&this->iterat, this);

	return &this->iterat;
}

/*
 * wbhXgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refHeadEntry(
	const AggregateList *this)
{
	return this->head;
}

/*
 * ̃XgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refNextEntry(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	return i_dst->next;
}

/*
 * Ήp
 */
STATIC void dummyFunc()
{
	printk("This operation not supported!\n");
	ASSERT(0);
}

//---------------------------- RXgN^ ------------------------------------

void AggregateListConstructor(
	AggregateList *this)
{
	// 
	this->head = NULL;
	this->end = NULL;
	this->insertHead = insertHead;
	this->insertEnd = insertEnd;
	this->insertNext = insertNext;
	this->insertPrev = insertPrev;
	this->removeEntry = removeEntry;
	this->getHead = getHead;
	this->getEnd = getEnd;
//	this->getNext = getNext;
//	this->getPrev = getPrev;
	this->refHead = refHead;
	this->refEnd = refEnd;
	this->refNext = refNext;
	this->refPrev = refPrev;
	this->pointHeadNext = (LIST_FUNC7) dummyFunc;
	this->removeOut = (LIST_FUNC8) dummyFunc;
	this->iterator = iterator;
	this->refHeadList = refHeadEntry;
	this->refNextList = refNextEntry;
}
