/*
 * AggregateList.h
 *
 * Copyright 2007; Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *sTvt
 * Iteratorp^[ListIteratorpAggregateList`
 */


#ifndef AggregateList_h
#define AggregateList_h


#include "List.h"
#include "IteratorList.h"
#include "test.h"


/*
 * XgW\
 */
typedef struct AggregateList {
	// 
	List			*head;		// Xgwb_
	List			*end;		// XgGh
	IteratorList	iterat;		// Ce[^[Gg[
	
	// 
	void			(*insertHead) (struct AggregateList *, List *);
	void			(*insertEnd) (struct AggregateList *, List *);
	void			(*insertNext) (struct AggregateList *, List *, List *);
	void			(*insertPrev) (struct AggregateList *, List *, List *);
	void			(*removeEntry) (struct AggregateList *, List *);
	OBJECT*			(*getHead) (struct AggregateList *);
	OBJECT*			(*getEnd) (struct AggregateList *);
//	OBJECT*			(*getNext) (struct AggregateList *, List *);
//	OBJECT*			(*getPrev) (struct AggregateList *, List *);
	OBJECT*			(*refHead) (const struct AggregateList *);
	OBJECT*			(*refEnd) (const struct AggregateList *);
	OBJECT*			(*refNext) (const struct AggregateList *, const List *);
	OBJECT*			(*refPrev) (const struct AggregateList *, const List *);
	void			(*pointHeadNext) (struct AggregateList *);
	void			(*removeOut) (const struct AggregateList *, List *);
	IteratorList*	(*iterator) (struct AggregateList *);
	List*			(*refHeadList) (const struct AggregateList *);
	List*			(*refNextList) (const struct AggregateList *, const List *);
} AggregateList;

typedef OBJECT* (*LIST_FUNC1) (struct AggregateList *);
typedef void (*LIST_FUNC2) (struct AggregateList *, List *);
typedef OBJECT* (*LIST_FUNC3) (struct AggregateList *, List *);
typedef void (*LIST_FUNC4) (struct AggregateList *, List *, List *);
typedef OBJECT* (*LIST_FUNC5) (const struct AggregateList *, const List *);
typedef OBJECT* (*LIST_FUNC6) (const struct AggregateList *);
typedef void (*LIST_FUNC7) (struct AggregateList *);
typedef void (*LIST_FUNC8) (const struct AggregateList *, List *);

extern void AggregateListConstructor(AggregateList *);
extern void AggregateSingleListConstructor(AggregateList *);
extern void AggregateScheduleConstructor(AggregateList *);


#endif
