/*
 * AggregateSchedule.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *sTvt
 * Iteratorp^[̃vZXXPW[zXgpB
 *
 *sOt
 * XVł̔r͌ĂяołsƁB
 */


#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include "IteratorList.h"
#include "AggregateList.h"
#include "test.h"


//================================== PRIVATE ============================================

/*
 * ڑvf̎ɐڑ
 */
STATIC INLINE void addNext(
	List *dst,
	List *src)
{
	src->next = dst->next;
	src->prev = dst;
	src->next->prev = src;
	dst->next = src;
}

/*
 * ڑvf̑Oɐڑ
 */
STATIC INLINE void addPrev(
	List *dst,		// ڑ惊Xgo[|C^
	List *src)		// ڑXgo[|C^
{
	src->next = dst;
	src->prev = dst->prev;
	dst->prev->next = src;
	dst->prev = src;
}

/*
 * Xg폜
 */
STATIC INLINE void erase(
	List *src)
{
	src->prev->next = src->next;	// nextŏɕς
	src->next->prev = src->prev;
	src->next =  NULL;
	src->prev = NULL;
}

//================================== PUBLIC =============================================

/*
 * Xgwb_ɐڑ
 *sOtڑXgGg[͏Ă邱
 */
STATIC void insertHead(
	AggregateList *this,
	List *m_list)
{
	if (this->head == NULL) {
		m_list->next = m_list->prev = m_list;
		this->head = m_list;
	}
	else {
		addPrev(this->head, m_list);
		this->head = m_list;
	}
}

/*
 * XgGg[̎ɐڑ
 */
STATIC void insertNext(
	AggregateList *this,
	List *m_dst,				// ڑGg[
	List *m_src)
{
	/*
	 * z͂ꂽGg[̎ɂڑł悤ɂ
	 */
	List *prev = m_dst->next->prev;
	
	addNext(prev, m_src);
	m_dst->next = m_src;
}

/*
 * XgGg[̑Oɐڑ
 */
STATIC void insertPrev(
	AggregateList *this,
	List *m_dst,				// ڑGg[
	List *m_src)
{
	// ڑXgGg[͏Ă邱
	addPrev(m_dst, m_src);
}

/*
 * XgGg[菜
 */
STATIC void removeEntry(
	AggregateList *this,
	List *m_list)
{
	// Gg[͐ڑĂ邱
	ASSERT(m_list != NULL);

	if (this->head == m_list) {
		if (m_list->next == m_list) {
			this->head = NULL;
		}
		else {
			this->head = m_list->next;
		}
	}
	erase(m_list);
}

/*
 * wbhGg[o
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *getHead(
	AggregateList *this)
{
	if (this->head != NULL) {
		List *headEntry = this->head;
		removeEntry(this, headEntry);

		return headEntry->object;
	}
	else {
		return NULL;
	}
}

/*
 * wbhGg[Q
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refHead(
	const AggregateList *this)
{
	if (this->head != NULL) {
		return this->head->object;
	}
	else {
		return NULL;
	}
}

/*
 * ̃Gg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refNext(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	return i_dst->next->object;
}

/*
 * ÕGg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refPrev(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	return i_dst->prev->object;
}

/*
 * wb_̎wGg[̃Gg[Ɉڂ
 */
void pointHeadNext(
	AggregateList *this)
{
	ASSERT(this->head != NULL);
	
	this->head = this->head->next;
}

/*
 * YGg[̑ÕGg[ɎwGg[AYGg[̎̃Gg[ɕςāA
 * zXg͂
 */
void removeOut(
	const struct AggregateList *this,
	List *m_list)
{
	m_list->prev->next = m_list->next;
	m_list->next->prev = m_list->prev;
}

//---------------------------- Ce[^[ ------------------------------------

STATIC IteratorList *iterator(
	AggregateList *this)
{
	IteratorListConstruct(&this->iterat, this);

	return &this->iterat;
}

/*
 * wbhXgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refHeadEntry(
	const AggregateList *this)
{
	return this->head;
}

/*
 * ̃XgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refNextEntry(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	if (i_dst->next != this->head) {
		return i_dst->next;
	}
	else {
		return NULL;
	}
}

/*
 * Ήp
 */
STATIC void dummyFunc()
{
	printk("This operation not supported!\n");
	ASSERT(0);
}

//---------------------------- RXgN^ ------------------------------------

void AggregateScheduleConstructor(
	AggregateList *this)
{
	// 
	this->head = NULL;
	this->end = NULL;
	this->insertHead = insertHead;
	this->insertEnd = (LIST_FUNC2) dummyFunc;
	this->insertNext = insertNext;
	this->insertPrev = insertPrev;
	this->removeEntry = removeEntry;
	this->getHead = getHead;
	this->getEnd = (LIST_FUNC1) dummyFunc;
//	this->getNext = getNext;
//	this->getPrev = getPrev;
	this->refHead = refHead;
	this->refEnd = (LIST_FUNC6) dummyFunc;
	this->refNext = refNext;
	this->refPrev = refPrev;
	this->pointHeadNext = pointHeadNext;
	this->removeOut = removeOut;
	this->iterator = iterator;
	this->refHeadList = refHeadEntry;
	this->refNextList = refNextEntry;
}
