/*
 * AggregateSingleList.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *sTvt
 * Iteratorp^[ListIteratorpPXgB
 *
 *sOt
 * XVł̔r͌ĂяołsƁB
 */


#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include "IteratorList.h"
#include "AggregateList.h"
#include "test.h"


//================================== PRIVATE ============================================

/*
 * ڑvf̎ɐڑ
 */
STATIC INLINE void addNext(
	List *dst,
	List *src)
{
	src->next = dst->next;
	dst->next = src;

}

//================================== PUBLIC =============================================

/*
 * Xgwb_ɐڑ
 *sOtڑXgGg[͏Ă邱
 */
STATIC void insertHead(
	AggregateList *this,
	List *m_list)
{
	ASSERT(m_list->next == NULL);

	if (this->head == NULL) {
		this->head = m_list;
		this->end = m_list;
	}
	else {
		m_list->next = this->head;
		this->head = m_list;
	}
}

/*
 * XgGhɐڑ
 *sOtڑXgGg[͏Ă邱
 */
STATIC void insertEnd(
	AggregateList *this,
	List *m_list)
{
	ASSERT(m_list->next == NULL);

	if (this->end == NULL) {
		this->head = m_list;
		this->end = m_list;
	}
	else {
		addNext(this->end, m_list);
		this->end = m_list;
	}
}

/*
 * XgGg[̎ɐڑ
 */
STATIC void insertNext(
	AggregateList *this,
	List *m_dst,				// ڑGg[
	List *m_src)
{
	// ڑXgGg[͏Ă邱
	ASSERT(m_src->next == NULL);

	addNext(m_dst, m_src);

	if (this->end == m_dst) {
		this->end = m_src;
	}
}

/*
 * wbhGg[o
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *getHead(
	AggregateList *this)
{
	if (this->head != NULL) {
		List *headEntry = this->head;
		this->head = headEntry->next;
		
		if (this->end == headEntry) {
			ASSERT(headEntry->next == NULL);

			this->end = NULL;
		}

		headEntry->next = NULL;

		return headEntry->object;
	}
	else {
		return NULL;
	}
}

/*
 * wbhGg[Q
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refHead(
	const AggregateList *this)
{
	if (this->head != NULL) {
		return this->head->object;
	}
	else {
		return NULL;
	}
}

/*
 * GhGg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refEnd(
	const AggregateList *this)
{
	if (this->end != NULL) {
		return this->end->object;
	}
	else {
		return NULL;
	}
}

/*
 * ̃Gg[QƂ
 * return : Gg[̏IuWFNg or NULL
 */
STATIC OBJECT *refNext(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	if (i_dst->next != NULL) {
		return i_dst->next->object;
	}
	else {
		return NULL;
	}
}

/*
 * Ήp
 */
STATIC void dummyFunc()
{
	printk("This operation not supported!\n");
	ASSERT(0);
}

//---------------------------- Ce[^[ ------------------------------------

STATIC IteratorList *iterator(
	AggregateList *this)
{
	IteratorListConstruct(&this->iterat, this);

	return &this->iterat;
}

/*
 * wbhXgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refHeadEntry(
	const AggregateList *this)
{
	return this->head;
}

/*
 * ̃XgGg[Q
 * return : XgGg[ or NULL
 */
STATIC List *refNextEntry(
	const AggregateList *this,
	const List *i_dst)
{
	ASSERT(i_dst != NULL);

	return i_dst->next;
}

//---------------------------- RXgN^ ------------------------------------

void AggregateSingleListConstructor(
	AggregateList *this)
{
	// 
	this->head = NULL;
	this->end = NULL;
	this->insertHead = insertHead;
	this->insertEnd = insertEnd;
	this->insertNext = insertNext;
	this->insertPrev = (LIST_FUNC4) dummyFunc;
	this->removeEntry = (LIST_FUNC2) dummyFunc;
	this->getHead = getHead;
	this->getEnd = (LIST_FUNC1) dummyFunc;
//	this->getNext = (LIST_FUNC3) dummyFunc;
//	this->getPrev = (LIST_FUNC3) dummyFunc;
	this->refHead = refHead;
	this->refEnd = refEnd;
	this->refNext = refNext;
	this->refPrev = (LIST_FUNC5) dummyFunc;
	this->pointHeadNext = (LIST_FUNC7) dummyFunc;
	this->removeOut = (LIST_FUNC8) dummyFunc;
	this->iterator = iterator;
	this->refHeadList = refHeadEntry;
	this->refNextList = refNextEntry;
}
