/*
 * BufPool.c
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *sړIt
 * ̃TCỸ[pɂɊĂꍇɁAԂZkB
 *
 *sTvt
 * ŏɑ傫ȃTCYŊ蓖ĂĂTCY؂oĂB
 *
 *sOt
 * ԂZk邽ߔr͂ĂȂ̂ŁA}`ANZXꍇ͌ĂяoŔrKvB
 */


#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "bitmap.h"
#include "BufPool.h"

#include "test.h"


//#define DEBUG_BUFPOOL 1
#ifdef DEBUG_BUFPOOL
	#define STATIC
	#define INLINE
#else
	#define STATIC	static
	#define INLINE	inline
#endif


//================================== ʒ` ===========================================

//================================== PRIVATE ============================================

//================================== PUBLIC =============================================

/*
 * gpobt@擾
 * return : gpobt@AhX or NULL
 */
void *allocBufPool(
	BufPool *m_bufPool)
{
	int unusedUnit = getBitmapEmptyPos(0, m_bufPool->maxUnits, m_bufPool->bitmap);
	
	if (unusedUnit == ERR) {
		return NULL;
	}
	
	setBitmapBit(unusedUnit, m_bufPool->bitmap);
	
	return (void*) ((uint) m_bufPool->bufPool + m_bufPool->unitBytes * unusedUnit);
}

/*
 * obt@J
 */
void freeBufPool(
	const void *unitAddr,
	BufPool *m_bufPool)
{
	int freeUnit = ((uint) unitAddr - (uint) m_bufPool->bufPool) / m_bufPool->unitBytes;
	
	ASSERT(freeUnit <= m_bufPool->maxUnits);
	
	resetBitmapBit(freeUnit, m_bufPool->bitmap);
}

/*
 * 
 */
void BufPoolConstruct(
	const int unitBytes,	// PPʂ̃oCg
	const int maxUnits,		// ŏɊ蓖Ă
	BufPool *m_bufPool)
{
	int bitmapSize;

	WARNING(unitBytes * maxUnits <= PAGE_SIZE);

	// obt@v[̊
	m_bufPool->bufPool = kmalloc(unitBytes * maxUnits);

	ASSERT(m_bufPool->bufPool != NULL);

	// rbg}bv̊Ɛݒ
	bitmapSize = sizeof(char) * ROUNDUP_DIV(maxUnits, BYTE_BITNUM);
	m_bufPool->bitmap = kmalloc(bitmapSize);

	ASSERT(m_bufPool->bitmap != NULL);

	memset(m_bufPool->bitmap, 0, bitmapSize);

	// o[̐ݒ
	m_bufPool->unitBytes = unitBytes;
	m_bufPool->maxUnits = maxUnits;
}

/*
 * I
 */
void BufPoolDestruct(
	BufPool *m_bufPool)
{
	int bitmapBytes = ROUNDUP_DIV(m_bufPool->maxUnits, BYTE_BITNUM);
	int i;
	
	// gp̃[邩H
	for (i = 0; i < bitmapBytes; ++i) {
		if (m_bufPool->bitmap[i] != 0) {
			WARNING(0);
			break;
		}
	}
	
	// [J
	kfree(m_bufPool->bitmap);
	kfree(m_bufPool->bufPool);
}
