#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "bitmap.h"
#include "BufPool.h"

#include "test.h"


void dump(BufPool *bufPlool)
{
	int i;
	
	for (i = 0; i < ROUNDUP_DIV(bufPlool->maxUnits, BYTE_BITNUM); ++i) {
		printf("%02x ", bufPlool->bitmap[i]);
	}
	printf("\n");
}

int main(int argc, char *argv[])
{
	BufPool bufPlool;

	BufPoolConstruct(4, 10, &bufPlool);

	for (;;) {
		int func;
		uint unit;

		scanf("%d %d", &func, &unit);

		switch (func) {
		case 1:
			printf("allocBufPool()=0x%x\n", allocBufPool(&bufPlool));
			dump(&bufPlool);
			break;
		case 2: {
			int *addr = (int*) bufPlool.bufPool + unit;
			freeBufPool(addr, &bufPlool);
			dump(&bufPlool);
			break;
		}
		default:
			printf("Unknown func number : %d!\n", func);
			break;
		}
	}

	BufPoolDestruct(&bufPlool);

	return 0;
}
