#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "test.h"


/******************************* eXgp` ******************************************/

enum {
	// z̃CfbNXŎgp̂ITIMER_VIRTUAL = 0,ITIMER_PROF = 1ŌŒ
	ITIMER_VIRTUAL =	0,
	ITIMER_PROF =		1,
	ITIMER_REAL =		2,

	ITIMER_MAX = 2,		// itimer
};

typedef int TIMER;

struct timeval {
	long	tv_sec;		/* seconds */
	long	tv_usec;	/* and microseconds */
};

struct itimerval {
    struct  timeval it_interval;    /* timer interval */
    struct  timeval it_value;   	/* current value */
};

typedef struct ITIMER{
	int64	init;		// liCPUNbNj
	int64	current;	// c莞ԁiCPUNbNj
} ITIMER;

typedef struct {
	ITIMER			itimer[ITIMER_MAX];	// itimer
	int 			procTimer;
} PROC;
static PROC proc;

static int handleAlarm;

static PROC *get_current_task()
{
	return &proc;
}

static void sendSignal(void *dummy1, int signal)
{
	printf("sendSignal() signal=%d\n", signal); 
}

uint64 calcMicroSecondFromClock(
	uint64 clock)		// micro seconds
{
	return clock;
}

uint64 calcClockFromMicroSecond(
	uint64 micro)		// s
{
	return micro;
}

int checkMem(const void *memory, size_t size)
{
	return NOERR;
}

int findTimerByHandle(void *a, ...)
{
	return -ENOENT;
}

void freeTimer(
	TIMER *m_timer)
{
}

static int allocProcessTimer(int a, ...)
{
	return NOERR;
}

static int getInitTime(TIMER *a) {
	return 0;
}

static int getRemainTime(TIMER *a) {
	return 0;
}

 static void dump();

/******************************* eXgR[h ******************************************/

//================================== PRIVATE ============================================

/*
 * vZXC^[o^C}[̏
 */
STATIC void initProcItimer(
	PROC *proc)
{
	proc->itimer[ITIMER_VIRTUAL].init = 0;
	proc->itimer[ITIMER_VIRTUAL].current = 0;
	proc->itimer[ITIMER_PROF].init = 0;
	proc->itimer[ITIMER_PROF].current = 0;
}

/*
 *sOtstruct timeval̒l0ȏł邱
 * struct timeval msԂ擾
 * return : mili seconds
 */
STATIC INLINE uint getMiliSecondsFromTimeval(
	const struct timeval *i_timeval)
{
	int miliSeconds;
	
	miliSeconds = i_timeval->tv_sec * 1000;
	miliSeconds += i_timeval->tv_usec / 1000;
	
	return miliSeconds;
}

/*
 * msԂstruct timevalZbg
 */
STATIC INLINE void setTimevalFromMiliSeconds(
	const uint i_miliSeconds,
	struct timeval *m_timeval)
{
	m_timeval->tv_sec = i_miliSeconds / 1000;
	m_timeval->tv_usec = (i_miliSeconds % 1000) * 1000;
}

/*
 * struct timevalCPUNbN擾
 */
STATIC INLINE uint64 getClocksFromTimeval(
	const struct timeval *i_timeval)
{
	uint64 clocks;
	
	clocks = calcClockFromMicroSecond(i_timeval->tv_sec * 1000000);
	clocks += calcClockFromMicroSecond(i_timeval->tv_usec);

	return clocks;
}

/*
 * CPUNbNstruct timevalZbg
 */
STATIC INLINE void setTimevalFromClocks(
	const uint64 i_clocks,
	struct timeval *m_timeval)
{
	uint64 microSeconds = calcMicroSecondFromClock(i_clocks);

	m_timeval->tv_sec = microSeconds / 1000000;
	m_timeval->tv_usec = microSeconds % 1000000;
}

/*
 * itimeritimerval̒lݒ肷
 */
STATIC void setItimervalFromItimer(
	const int i_which,
	struct itimerval *m_itimerval)
{
	ITIMER *itimer = &get_current_task()->itimer[i_which];
	
	setTimevalFromClocks(itimer->init, &m_itimerval->it_interval);
	setTimevalFromClocks(itimer->current, &m_itimerval->it_value);
}

/*
 * itimervalitimer̒lݒ肷
 */
STATIC void setItimerFromItimerval(
	const int i_which,
	const struct itimerval *i_itimerval)
{
	ITIMER *itimer = &get_current_task()->itimer[i_which];
	
	itimer->init = getClocksFromTimeval(&i_itimerval->it_interval);
	itimer->current = getClocksFromTimeval(&i_itimerval->it_value);
}

/*
 * C^[o^C}[s
 */
STATIC void doItimer(
	const int i_which,
	const int64 clocks,		// oCPUNbN
	const int signal)		// ^C}[oߎɑVOi
{
	ITIMER *itimer = &get_current_task()->itimer[i_which];
	
	if (0 < itimer->current) {
		itimer->current -= clocks;
		if (itimer->current <= 0) {
			sendSignal(get_current_task(), signal);
			itimer->current = itimer->init;
		}
	}
}

//================================== PUBLIC =============================================

/*
 * VXeoߎԂɂC^[o^C}[
 */
void doSystemItimer(
	const int64 clocks)		// oCPUNbN
{
	doItimer(ITIMER_PROF, clocks, SIGPROF);
}

/*
 * [U[oߎԂɂC^[o^C}[
 */
void doUserItimer(
	const int64 clocks)		// oCPUNbN
{
	doItimer(ITIMER_PROF, clocks, SIGPROF);
	doItimer(ITIMER_VIRTUAL, clocks, SIGVTALRM);
}

int sys_getitimer(const int i_which, struct itimerval *m_itimerval)
{
	if (checkMem(m_itimerval, sizeof(*m_itimerval)) == -1){
		return -EFAULT;
	}

	switch (i_which) {
	case ITIMER_VIRTUAL:
		// 
	case ITIMER_PROF:
		setItimervalFromItimer(i_which, m_itimerval);
		break;
	case ITIMER_REAL: {
		TIMER *timer;

		if (findTimerByHandle(&get_current_task()->procTimer, handleAlarm, &timer) == NOERR) {
			// ݂̎Ԃ
			setTimevalFromMiliSeconds(getInitTime(timer), &m_itimerval->it_interval);
			setTimevalFromMiliSeconds(getRemainTime(timer), &m_itimerval->it_value);
		}
		break;
	}
	default:
		return -EFAULT;
	}

	return 0;
}

int sys_setitimer(
	const int i_which,
	const struct itimerval *i_itimerval,
	struct itimerval *m_itimerval)
{
	if (checkMem(i_itimerval, sizeof(*i_itimerval)) == -1){
		return -EFAULT;
	}
	if (m_itimerval != NULL){
		if (checkMem(m_itimerval, sizeof(*m_itimerval)) == -1){
			return -EFAULT;
		}
	}
	if ((i_itimerval->it_interval.tv_sec < 0) || 
		(i_itimerval->it_interval.tv_usec < 0) ||
		(i_itimerval->it_value.tv_sec < 0) || 
		(i_itimerval->it_value.tv_usec < 0)) {
		return -EINVAL;
	}

	switch (i_which) {
	case ITIMER_VIRTUAL:
		// 
	case ITIMER_PROF:
		if (m_itimerval != NULL) {
			setItimervalFromItimer(i_which, m_itimerval);
		}
		setItimerFromItimerval(i_which, i_itimerval);
		break;
	case ITIMER_REAL: {
		TIMER *timer;
		uint initTime = getMiliSecondsFromTimeval(&i_itimerval->it_interval);
		uint time = getMiliSecondsFromTimeval(&i_itimerval->it_value);

		if (0 == time) {
			time = initTime;
			if (0 == time) {
				break;
			}
		}

		// A[^C}[ɂΉ
		if (findTimerByHandle(&get_current_task()->procTimer, handleAlarm, &timer) == NOERR) {
			if (m_itimerval != NULL) {
				// ݂̎Ԃ
				setTimevalFromMiliSeconds(getInitTime(timer), &m_itimerval->it_interval);
				setTimevalFromMiliSeconds(getRemainTime(timer), &m_itimerval->it_value);
			}
			freeTimer(timer);
		}

		// A[^C}[ݒ
		allocProcessTimer(time, initTime, handleAlarm, get_current_task(), &timer);

		break;
	}
	default:
		return -EFAULT;
	}

	return 0;
}

/******************************* _v ******************************************/

static void printEntry(
	ITIMER *Itimer)
{
	printf("%08d-", Itimer->init);
	printf("%08d\n", Itimer->current);
}

static void dump(
	const struct itimerval *itimerval)
{
	printf("ITIMER_VIRTUAL\n");
	printEntry(&proc.itimer[ITIMER_VIRTUAL]);

	printf("ITIMER_PROF\n");
	printEntry(&proc.itimer[ITIMER_PROF]);

	if (itimerval != NULL) {
		printf("itimerval\n"
			"it_interval.tv_sec=%08d it_interval.tv_usec=%08d\n"
			"it_value.tv_sec=   %08d it_value.tv_usec=   %08d\n",
			itimerval->it_interval.tv_sec,
			itimerval->it_interval.tv_usec,
			itimerval->it_value.tv_sec,
			itimerval->it_value.tv_usec);
	}

	printf("\n");
}

/******************************************************************************************/

int main(int argc, char *argv[])
{
	initProcItimer(&proc);

	for (;;) {
		int func;
		int initMicro;
		int currentMicro;
		struct itimerval itimerval;
		struct itimerval m_itimerval;

		scanf("%d %d %d", &func, &initMicro, &currentMicro);

		switch (func) {
		case 11:
			itimerval.it_interval.tv_sec = initMicro / 1000000;
			itimerval.it_interval.tv_usec = initMicro % 1000000;
			itimerval.it_value.tv_sec = currentMicro / 1000000;
			itimerval.it_value.tv_usec = currentMicro % 1000000;
			sys_setitimer(ITIMER_VIRTUAL, &itimerval, &m_itimerval);

			dump(&m_itimerval);
			break;
		case 12:
			itimerval.it_interval.tv_sec = initMicro / 1000000;
			itimerval.it_interval.tv_usec = initMicro % 1000000;
			itimerval.it_value.tv_sec = currentMicro / 1000000;
			itimerval.it_value.tv_usec = currentMicro % 1000000;
			sys_setitimer(ITIMER_PROF, &itimerval, &m_itimerval);

			dump(&m_itimerval);
			break;
		case 13:
			m_itimerval.it_interval.tv_sec = initMicro / 1000000;
			m_itimerval.it_interval.tv_usec = initMicro % 1000000;
			m_itimerval.it_value.tv_sec = currentMicro / 1000000;
			m_itimerval.it_value.tv_usec = currentMicro % 1000000;
			sys_setitimer(ITIMER_REAL, &itimerval, &m_itimerval);

			dump(NULL);
			break;
		case 14:
			itimerval.it_interval.tv_sec = initMicro / 1000000;
			itimerval.it_interval.tv_usec = initMicro % 1000000;
			itimerval.it_value.tv_sec = currentMicro / 1000000;
			itimerval.it_value.tv_usec = currentMicro % 1000000;
			printf("sys_setitimer=%d\n", sys_setitimer(3, &itimerval, &m_itimerval));

			break;
		case 21:
			sys_getitimer(ITIMER_VIRTUAL, &m_itimerval);
			dump(&m_itimerval);
			break;
		case 22:
			sys_getitimer(ITIMER_PROF, &m_itimerval);
			dump(&m_itimerval);
			break;
		case 23:
			m_itimerval.it_interval.tv_sec = initMicro / 1000000;
			m_itimerval.it_interval.tv_usec = initMicro % 1000000;
			m_itimerval.it_value.tv_sec = currentMicro / 1000000;
			m_itimerval.it_value.tv_usec = currentMicro % 1000000;
			sys_getitimer(ITIMER_REAL, &m_itimerval);
			dump(&m_itimerval);
			break;
		case 24:
			printf("sys_getitimer=%d\n", sys_getitimer(3, &m_itimerval));
			break;
		case 3:
			doSystemItimer(initMicro);
			dump(NULL);
			break;
		case 4:
			doUserItimer(initMicro);
			dump(NULL);
			break;
		default:
			printf("Unknown func number : %d!\n", func);
			break;
		}
	}

	return 0;
}
