/*
 * timer.h
 *
 * Copyright 2007, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef timer_h
#define timer_h


#include <sys/time.h>
#include <kern/AggregateList.h>


#ifndef ASM_FILE


enum{
	ITIMER_MAX = 2,		// itimer
};

/*
 * ޡ¤νͭإå
 */
typedef struct {
	AggregateList	aggregate;	// ޡ󥯽
	int				count;		// 󥯥ޡ
	int				lock;		// ԥå
} TIMER_OWNER;

typedef struct ITIMER{
	int64	init;		// ͡CPUå
	int64	current;	// Ĥ֡CPUå
} ITIMER;

extern void doRealTimer(const uint);
extern void doIntervalTimer(const uint);
extern void doSystemItimer(const int64);
extern void doUserItimer(const int64);
extern void delWakeTimer(void*);
extern int setDevWakeTimer(const uint, void**);
extern int setTasking(const uint);
extern int sys_sleep();
extern int sys_alarm();
extern void initTimer();
extern void initProcTimer(void*);
extern void releaseProcTimer();
extern void sys_wake(void*);
extern void micro_timer(uint);
extern void mili_timer(uint);
extern int sys_getitimer();
extern int sys_setitimer();


#endif


#endif
