/*
 * netlib.h
 *
 * Copyright 2006, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef netlib_h
#define netlib_h


#include <sys/types.h>
#include <sys/ip.h>
#include <sys/select.h>
#include <kern/mm.h>
#include <net/net.h>
#include <net/ip.h>
#include <net/tcp.h>


#ifndef ASM_FILE


// TCPХȿ֤
extern inline int getIpSize(IP_HEADER *ip)
{
	return swapWord(ip->len);
}

extern ushort calcSum(uint*,int);
extern ushort calcSumM(uint*,uint*,int,int);

extern int allocRingBuf(const size_t, const size_t, void**);
extern void freeRingBuf(void*);
extern size_t getStartRingBuf(void*);
extern size_t getLastRingBuf(void*);
#define getCurrentRingBuf getLastRingBuf
extern void setStartRingBuf(void*, size_t);
extern int getSizeRingBuf(void*);
extern int getAvailableSizeRingBuf(void*);
extern void readRingBuf(void*, const size_t, const size_t, char*);
extern void writeRingBuf(void*, const size_t, const char*);
extern int getOpt(SOCKET*,int,int,int*,int*);
extern int setOpt(SOCKET*,int,int,const int*,int);
extern void doSockOpt(SOCKET*, caddr_t, u_int);


#endif


#endif
